package httpx

import (

	"github.com/d5/tengo/v2"
	//"github.com/d5/tengo/v2/stdlib"
	"surdeus.su/util/tpp/mdx"
	"surdeus.su/core/cli/mtool"
	"net/http"
	"log"
	//"context"
)

// Context key type for internal usage.
type CKey string

const (
	KeyRequest CKey = "http-request"
	KeyGlobal = "global"
	KeyMarkdown = "markdown"
)

// Simple PHP-like server implementation.
var Tool = mtool.T("tht").Func(func(flags *mtool.Flags) {
	var (
		addr, ext, src, mod string
	)

	flags.StringVar(&addr, "addr", ":3000", "address to serve at")
	flags.StringVar(&mod, "mod", "./mod", "path to store Tengo modules")
	flags.StringVar(&src, "src", "./src", "directory with source files")
	flags.StringVar(&ext, "ext", ".tpp", "extension for TPP files")

	flags.Parse()


	srv := &http.Server{
		Addr:    addr,
		Handler: NewHandler(
			DefaultPP(mod),
			src, ext,
			map[string] tengo.Object{},
		).SetMD(mdx.MakeDefaultMarkdown()),
	}

	log.Printf("Listening on %q\n", addr)
	err := srv.ListenAndServe()
	if err != nil {
		log.Printf("Error: srv.ListenAndServe(...): %s\n", err)
	}
})
